class Seed extends DNA {

  public PVector pos;
  public int age;
  public boolean alive = true;
  private int spawnAge = 365;
  private float seedRadius = 32;
  
  Seed () {
    pos = new PVector(random(width), random(height));
    createGenes();
  }
  Seed (ArrayList<Float> oldGenes) {
    pos = new PVector(random(width), random(height));
    createGenes(oldGenes);
  }
  Seed (float x, float y) {
    pos = new PVector(x, y); 
    createGenes();
  }
  Seed (float x, float y, ArrayList<Float> oldGenes) {
    pos = new PVector(x, y); 
    createGenes(oldGenes);
  }
  Seed (float x, float y, ArrayList<Float> genes1, ArrayList<Float> genes2) {
    pos = new PVector(x, y); 
    createGenes(genes1, genes2);
  }


  private float spawnRadius () {
    return 10 + constrain(age/100,0,20);
  }
  
  
  public void display () {
    noStroke();
    fill(150,50,0);
    ellipse(pos.x,pos.y,2,2);
  }
  
  public void step () {
    age += 1;
    if (age % spawnAge == 0) {
      spawn();
    }
  }
  
  private void spawn () {
    Tree t;
    for (int i = 0; i < trees.size(); i++) {
      t = trees.get(i);
      if (pow(t.pos.x-pos.x,2)+pow(t.pos.y-pos.y,2) < pow(seedRadius,2)) {
        die();
        return; // dont grow the tree
      }
    }
    if (random(0,1) > 0.9) {
      trees.add(new Tree(pos.x, pos.y, genes));
    }
    die();
  }
  
  public void die () {
    alive = false;
  }
}

